﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace POCAddIn.Extensions
{
    public static class ExtensionMethods
    {
        public static void ReleaseComObject<T>(this T resource) where T : class
        {
            if (resource != null && Marshal.IsComObject(resource))
            {
                int r = Marshal.ReleaseComObject(resource);
                while (r > 0)
                {
                    r = Marshal.ReleaseComObject(resource);
                }
            }


        }


        public static void FinalReleaseComObject<T>(this T resource) where T : class
        {
            try
            {
                if (resource != null && Marshal.IsComObject(resource))
                {
                    int r = Marshal.FinalReleaseComObject(resource);
                    while (r > 0)
                    {
                        r = Marshal.FinalReleaseComObject(resource);
                    }
                }
            }
            catch (Exception e)
            {
                //do nothing

            }

        }


        
    }
}
