﻿using System;
using System.Threading.Tasks;
using Outlook = Microsoft.Office.Interop.Outlook;
using Microsoft.Office.Tools;


using System.Windows.Controls;
using System.Runtime.InteropServices;

namespace POCAddIn.Wrappers
{
    internal sealed class OutlookExplorerWrapper : GenericOutlookContainer<Outlook.Explorer>
    {

        //IWorkItemViewModel _wiVM;
        //ILifetimeScope _wiLifeTimeScope;

        internal OutlookExplorerWrapper(Outlook.Explorer exp)
            : base(exp)
        {

        }

       

        protected internal override void GenericOutlookContainer_Deactivate()
        {
            Logger.Debug(this, "Explorer window deactivated");
            
        }
        protected override void RefreshRibbon()
        {
            try
            {
                RibbonState state = RibbonState.Create;

                if (OutlookObject.Selection.Count > 0)
                {
                    object item = OutlookObject.Selection[1];


                    var mail = item as Microsoft.Office.Interop.Outlook.MailItem;

                    if (mail != null)
                    {
                        Logger.Debug(this, "Capturing mail body");
                        var s = mail.Body;
                        Marshal.ReleaseComObject(mail);
                        mail = null;
                    }
                    
                    item = null;
                    GC.Collect();
                    GC.WaitForPendingFinalizers();
                    GC.Collect();
                    GC.WaitForPendingFinalizers();
                }
                else
                    state = RibbonState.Create;

                //base._ribbonContainer.RefreshRibbon(state);
            }
            catch (Exception ex)
            {
                Logger.Error(this, ex, "Refresh Ribbon call failed");

            }
        }
        protected internal override void GenericOutlookContainer_Activate()
        {
            String message = String.Format("Outlook Explorer calling Activate method.");

            Logger.Debug(this, message);
            RefreshRibbon();
        }


        //private async Task RefreshTaskPaneAsNeeded(OutLookWrapperBase selectedItem)
        //{
        //    if (CustomTaskPane.Visible)
        //    {
        //        if (_wiVM == null) //loading the workitemview model for the first time for this selected outlook explorer object. If the user simply keeps on clicking the show/hide button we dont want to do this again and again
        //        {
        //            if (_wiLifeTimeScope == null)
        //                _wiLifeTimeScope = LifeTimeScope.BeginLifetimeScope();

        //            _wiVM = _wiLifeTimeScope.Resolve<IWorkItemViewModel>();
        //            WpfPanelHost host = CustomTaskPane.Control as WpfPanelHost;
        //            if (host != null)
        //            {
        //                ScrollViewer scrollViewer = host.Child as ScrollViewer;
        //                var contentHOst = scrollViewer.Content as ITaskPaneContentHost;
        //                if (contentHOst != null)
        //                    contentHOst.AddOrActivate(_wiVM);
        //            }
        //            //await _wiVM.Initialise(SelectedOutlookItem, false);
        //            await _wiVM.Initialise(selectedItem, false);
        //        }
        //    }
        //}

        //private async void Handle_Selection_Change(OutLookWrapperBase selectedItem)
        //{
        //    /* In the main outlook explorer the chances are that the main outlook window
        //     * will be left open for a long time. So we can potentially end up with a lot of IWOrkItemViewModel Instances
        //     * that autofac will simply not release as this wrapper object is per outlook explorer window
        //     * Thus for every selection change we will instantiate a new child scope for autofac and use that to resolve workitems
        //     * Once the user changes the selection again, we simply dispose of the child lifetimescope
        //     * while keeping the master scope intact.
        //     * The master scope is disposed of by the base class as usual while closing down outlook
        //     * */

        //    RefreshRibbon();

        //    if (_wiLifeTimeScope != null)
        //    {
        //        _wiLifeTimeScope.Dispose();
        //        _wiLifeTimeScope = null;
        //    }
        //    _wiVM = null;


        //    await RefreshTaskPaneAsNeeded(selectedItem);


        //}
        private string _previousEntryId = String.Empty;
        internal override void _explorer_SelectionChange()
        {
            
            //try
            //{
            //    if (OutlookObject.Selection.Count > 0)
            //    {
            //        object item = OutlookObject.Selection[1];

            //        using (OutLookWrapperBase selectedItem = OutLookWrapperBase.GetWrappedInstance(item))
            //        {
            //            if (!_previousEntryId.Equals(selectedItem.EntryId))
            //            {
            //                Handle_Selection_Change(selectedItem);
            //                _previousEntryId = selectedItem.EntryId;
            //            }
            //            //else
            //            //    Logger.Debug(this, "Handle Selection Change not fired as EntryIDs are equal ");
            //            selectedItem.Dispose();
            //        }


            //        //selectedItem.Dispose();
            //        //selectedItem = null;

            //        //if (String.IsNullOrEmpty(selectedItem.MessageClass)) //not one of the outlook objects we wrap
            //        item.ReleaseComObject();


            //    }
            //}
            //catch (Exception e)
            //{

            //    Logger.Error(this, e, String.Empty);
            //}
        }

        protected override void GenericOutlookContainer_Close()
        {
            //if (SelectedOutlookItem != null)
            //{

            //    SelectedOutlookItem.Dispose();
            //    SelectedOutlookItem = null;

            //}

            //if (_wiLifeTimeScope != null)
            //{
            //    _wiLifeTimeScope.Dispose();
            //    _wiLifeTimeScope = null;
            //}
            base.GenericOutlookContainer_Close();
        }

        public override void Dispose()
        {
            GenericOutlookContainer_Close();
        }
    }
}
