﻿using Microsoft.Office.Core;
using POCAddIn.Ribbons;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;

using Office = Microsoft.Office.Core;
using Outlook = Microsoft.Office.Interop.Outlook;
// TODO:  Follow these steps to enable the Ribbon (XML) item:

// 1: Copy the following code block into the ThisAddin, ThisWorkbook, or ThisDocument class.

//  protected override Microsoft.Office.Core.IRibbonExtensibility CreateRibbonExtensibilityObject()
//  {
//      return new Ribbon();
//  }

// 2. Create callback methods in the "Ribbon Callbacks" region of this class to handle user
//    actions, such as clicking a button. Note: if you have exported this Ribbon from the Ribbon designer,
//    move your code from the event handlers to the callback methods and modify the code to work with the
//    Ribbon extensibility (RibbonX) programming model.

// 3. Assign attributes to the control tags in the Ribbon XML file to identify the appropriate callback methods in your code.  

// For more information, see the Ribbon XML documentation in the Visual Studio Tools for Office Help.

//http://msdn.microsoft.com/en-us/library/bb772076.aspx

namespace POCAddIn
{
    /*This is treated as a singleton by Outlook
   * */
    [ComVisible(true)]
    public class Ribbon : IRibbonContainer
    {
        private Office.IRibbonUI ribbon;

        WpfPanelHost _host = null;
        Microsoft.Office.Tools.CustomTaskPane _pane;
        public Ribbon()
        {

        }



        
        public string GetContent(IRibbonControl control)
        {
            string timeNow = DateTime.Now.ToLongTimeString();
            StringBuilder MyStringBuilder = new StringBuilder(@"<menu xmlns=""http://schemas.microsoft.com/office/2006/01/customui"" >");
            MyStringBuilder.Append(@"<button id=""button1"" label=""Insert Text " + timeNow + @""" onAction=""OnAction""  imageMso=""SignatureLineInsert"" tag=""button1"" />");
            MyStringBuilder.Append(@"<menuSeparator id=""menusep1""  />");
            MyStringBuilder.Append(@"<button id=""button2"" label=""Insert More Text " + timeNow + @""" onAction=""OnAction"" imageMso=""FileDocumentInspect"" tag=""button2"" />");
            MyStringBuilder.Append(@"</menu>");
            return MyStringBuilder.ToString();
        }

        public void OnAction(IRibbonControl control)
        {
            switch (control.Id)
            {
                case "button1": break;
                case "button2": break;
                case "button3": break;
                default: break;
            }
        }

        #region IRibbonExtensibility Members

        public string GetCustomUI(string ribbonID)
        {
//            TfsLogManager.Instance.Debug("Ribbon.cs GetCustomUI called for ", ribbonID);
            /*
             * Ribbon Id: Microsoft.Outlook.Contact
             * Microsoft.Outlook.Task
             * Microsoft.Outlook.Journal
             * Microsoft.Outlook.Mail.Compose
             * */
            switch (ribbonID)
            {
                case "Microsoft.Outlook.Explorer": return GetResourceText("POCAddIn.Ribbon.xml");
                case "Microsoft.Outlook.Mail.Read": return GetResourceText("POCAddIn.MailRead.xml");
                case "Microsoft.Outlook.Task": return GetResourceText("POCAddIn.TaskItem.xml");
                //case "Microsoft.Outlook.Mail.Read": return GetResourceText("POCAddIn.Ribbon.xml");
                default: return String.Empty;
            }

        }

        private bool _disable = true;
        public bool DisableOtherButton(IRibbonControl rc)
        {
            return _disable;
        }
     


        #endregion

        #region Ribbon Callbacks
        //Create callback methods here. For more information about adding callback methods, visit http://go.microsoft.com/fwlink/?LinkID=271226

        public void Ribbon_Load(Office.IRibbonUI ribbonUI)
        {

            this.ribbon = ribbonUI;
            ThisAddIn.RibbonUI = ribbonUI;

            //var inspectors = Globals.ThisAddIn.Application.Inspectors;
            //TfsLogManager.Instance.Debug(this, "Inspector count at ribbon load ", inspectors != null ? inspectors.Count.ToString() : " inspectors was null");
        }

        #endregion

        #region Helpers

        private static string GetResourceText(string resourceName)
        {
            Assembly asm = Assembly.GetExecutingAssembly();
            string[] resourceNames = asm.GetManifestResourceNames();
            for (int i = 0; i < resourceNames.Length; ++i)
            {
                if (string.Compare(resourceName, resourceNames[i], StringComparison.OrdinalIgnoreCase) == 0)
                {
                    using (StreamReader resourceReader = new StreamReader(asm.GetManifestResourceStream(resourceNames[i])))
                    {
                        if (resourceReader != null)
                        {
                            return resourceReader.ReadToEnd();
                        }
                    }
                }
            }
            return null;
        }

        #endregion

        public void RefreshRibbon(RibbonState state)
        {
            
        }
    }


}
